import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;

public class HashTableForPopupMenu extends JFrame implements ActionListener, MouseListener{
	public static void main(String argv[]){
		new HashTableForPopupMenu().setVisible(true);
	}

	public HashTableForPopupMenu(){
		MenuBar mb = new MenuBar();
		setMenuBar(mb);
		Menu m = new Menu("File");
		mb.add(m);
		MenuItem item = new MenuItem("First Menu");
		item.addActionListener(this);
		m.add(item);
		item = new MenuItem("Second Menu");
		m.add(item);
		item.addActionListener(this);
		setSize(400, 400);
		setLayout(new BorderLayout());
		Label l = new Label("label");
		addPopup(l, "label");
		add(l, "North");
		Panel p = new Panel();
		addPopup(p, "Panel");
		add(p, "Center");
		Button b = new Button("button");
		b.addActionListener(this);
		addPopup(b, "button");
		add(b, "South");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public void actionPerformed(ActionEvent e){
		JOptionPane.showMessageDialog(null,"This simple Action Event.\nSource=" + e.getSource());
	}

	public void mouseClicked(MouseEvent e){
		mouseAction("mouseClicked", e);
	}

	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	
	public void mousePressed(MouseEvent e){
		mouseAction("mousePressed", e);
	}

	public void mouseReleased(MouseEvent e){
		mouseAction("mouseReleased", e);
	}

	void mouseAction(String which, MouseEvent e){
		Component c = e.getComponent();
		if(e.isPopupTrigger()){
			JOptionPane.showMessageDialog(null,"Right Click");
			PopupMenu pm = getHash(c);
			pm.show(c, c.getSize().width/2, c.getSize().height/2);
		}
	}
	
	void addPopup(Component c, String name){
		PopupMenu pm = new PopupMenu();
		MenuItem mi = new MenuItem(name + "-1");
		mi.addActionListener(this);
		pm.add(mi);
		mi = new MenuItem(name + "-2");
		mi.addActionListener(this);
		pm.add(mi);
		setHash(c, pm);
		c.add(pm);
		c.addMouseListener(this);
	}
	
	Hashtable<Component,PopupMenu> popupTable = new Hashtable<Component,PopupMenu>();
	void setHash(Component c, PopupMenu p){
		popupTable.put(c, p);
	}
	
	PopupMenu getHash(Component c){
		return (PopupMenu)(popupTable.get(c));
	}
}
